<?php
/**
 * @name srv_control.php
 * @description Fichier principal du plugin serveur
 * @author Nicolas Biersart <n.biersart@esia-sa.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 09/11/2012
 */
$path = $_SERVER['DOCUMENT_ROOT'];
// $webp_name doit être identique au nom de la base de données !!!
$webp_name='ups';
//$webp_model='model_'.$webp_name.'.php';
//Inclusion des librairie
include_once $path.'common.php';
include_once $path.'/Model_adm.php';

/*DESCRIPTION: inclus les variables habituelles pour la gestion d'un noeud et vérifie les droits d'accès
 *NECESSITE: la variable $webp_name configurée
 *           la variable $webp_model est incluste
 *APRES l'inclusion du common_node_control les variables suivantes sont créées:
 *PHP:
 *      $node objet de type device
 *      $template_path chemin d'accès vers le répertoire template du plugin (exemple: /usr/local/esia/public_html/plugin/server/templates/)
 *      $apache_plugin_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_info = array('id'=>$node->getId(),
                    'name'=>$node->getName(),
				    'ip'=>$node->getIPAddress(),
				    'id'=>$node->getId(),
				    'description'=>$node->getDescription(),
				    'group'=>$node->getGroup());
 * SMARTY
        $webp_name nom du plugin
        $node avec les donnée de node_info (voir au dessus)
 *      $apache_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_status pour l'affichage commun des noeuds si $_GET['tab'] est vide
 *
 */
include_once $path.'/inc/common_node_control.php';
//Variable passé en paramètre

$tab='';
if(isset($_GET['tab'])&& !empty($_GET['tab']))
{
	$tab=$_GET['tab'];
}
$action='';
if(isset($_GET['action'])&& !empty($_GET['action']))
{
	$action=$_GET['action'];
}
$smarty->assign('tab', $tab);

if((isset($_SESSION['random']) && isset($_POST['randomForm'])) && $_SESSION['random'] == $_POST['randomForm'])
{
	if(isset($_POST['check-1-output']) || isset($_POST['check-2-output']) || isset($_POST['check-3-output']) )
	{	
		$plugin="";
		$pattern="";
		$replace="";
		if(get_class($node)=='RemoteDevice')
		{
			$plugins = Model_esia::getPlugin($dbconnection,"GESA_SNMP_UPS_LINE");
			$plugin = $plugins[0];
			$pattern='#$SNMP_COM\s[0-9]#';
			$replace='$SNMP_COM ';
		}
		else
		{
			$plugins = Model_esia::getPlugin($dbconnection,"CHECK_SNMP_UPS_LINE");
			$plugin = $plugins[0];
			$pattern="#-m\s[0-9]#";
			$replace="-m ";
		}
		$parameter = $plugin['parameter'];
		if($_POST['check-1-output'] == "1")
		{
			$replace.="1";
			$parameter = preg_replace($pattern,$replace,$parameter);
			model_adm::addService($dbconnection,$plugin['name'].'_1',$plugin['id'],$_GET['nodeid'],$plugin['interval_time'],$parameter,$plugin['priority'],null,null);
		}
		if($_POST['check-2-output'] == "2")
		{
			$replace.="2";
			$parameter = preg_replace($pattern,$replace,$parameter);
			model_adm::addService($dbconnection,$plugin['name'].'_2',$plugin['id'],$_GET['nodeid'],$plugin['interval_time'],$parameter,$plugin['priority'],null,null);
		}
		if($_POST['check-3-output'] == "3")
		{
			$replace.="3";
			$parameter = preg_replace($pattern,$replace,$parameter);
			model_adm::addService($dbconnection,$plugin['name'].'_3',$plugin['id'],$_GET['nodeid'],$plugin['interval_time'],$parameter,$plugin['priority'],null,null);
		}
	}
	if(isset($_POST['check-1-input']) || isset($_POST['check-2-input']) || isset($_POST['check-3-input']) )
	{
		$plugin="";
		$pattern="";
		$replace="";
		if(get_class($node)=='RemoteDevice')
		{
			$plugins = Model_esia::getPlugin($dbconnection,"GESA_SNMP_UPS_INPUT");
			$plugin = $plugins[0];
			$pattern='#$SNMP_COM\s[0-9]#';
			$replace='$SNMP_COM ';
		}
		else
		{
			$plugins = Model_esia::getPlugin($dbconnection,"CHECK_SNMP_UPS_INPUT");
			$plugin = $plugins[0];
			$pattern="#-m\s[0-9]#";
			$replace="-m ";
		}
		$parameter = $plugin['parameter'];
		if($_POST['check-1-input'] == "1")
		{
			$replace.="1";
			$parameter = preg_replace($pattern,$replace,$parameter);
			model_adm::addService($dbconnection,$plugin['name'].'_1',$plugin['id'],$_GET['nodeid'],$plugin['interval_time'],$parameter,$plugin['priority'],null,null);
		}
		if($_POST['check-2-input'] == "2")
		{
			$replace.="2";
			$parameter = preg_replace($pattern,$replace,$parameter);
			model_adm::addService($dbconnection,$plugin['name'].'_2',$plugin['id'],$_GET['nodeid'],$plugin['interval_time'],$parameter,$plugin['priority'],null,null);
		}
		if($_POST['check-3-input'] == "3")
		{
			$replace.="3";
			$parameter = preg_replace($pattern,$replace,$parameter);
			model_adm::addService($dbconnection,$plugin['name'].'_3',$plugin['id'],$_GET['nodeid'],$plugin['interval_time'],$parameter,$plugin['priority'],null,null);
		}
	}
	$_SESSION['random'] = rand(100000,999999);
}
//session_write_close();
try
{

    if($tab=='servicestate')
    {
		// Recupération logo constructeur
		include_once $path.'/libs/logo_oid.hash.php';
		$objectid = $node->getSysObjectId();
        $logo = IANA::getManufacturerLogo($objectid, $node->getSysDescr());
		$smarty->assign('manufacturer_logo',$logo['logo']);

		// Récupération information systeme
		$smarty->assign('sysname',$node->getSysName());
		$smarty->assign('sysdescr',$node->getSysDescr());
		$smarty->assign('syslocation',$node->getSysLocation());
		$smarty->assign('syscontact',$node->getSysContact());

		//Récupération du poucentage de chaque Ligne
        $result = Model_esia::getServices($dbconnection,$_GET['nodeid']);
		$arrayResult = array();
		$isActive = false;
		$index = 0;
		$arrayResult['Line1']['isActive'] = 0;
		$arrayResult['Line2']['isActive'] = 0;
		$arrayResult['Line3']['isActive'] = 0;
		$arrayResult['batteryState'] = "UNKNOWN";
		
		foreach($result as $service)
		{
 				if($service['check_plugin_name'] == "CHECK_SNMP_UPS_LINE" || $service['check_plugin_name'] == "GESA_SNMP_UPS_LINE")
				{
					$line = explode(':',$service["stdout"]);
					$posPercent = strpos($line[2],'%');
					$percent = substr($line[2],$posPercent-2,$posPercent);
					$percent = substr($percent,0,2);
					if(preg_match('#([0-9]*)\%#',$service["stdout"],$regs))
					{
						$percent = $regs[1];
					}
					if(strpos($line[1],"Line 1"))
					{
						$arrayResult['Line1']['id'] = $service['id'];

						$arrayResult['Line1']['Line'] = $percent;
						$arrayResult['Line1']['State'] = $line[0];
						$arrayResult['Line1']['Volt'] = $service['value']['volt'];
						if(!empty($line[0]))
						{
						 	$isActive = true;
						}
						$arrayResult['Line1']['isActive'] = $isActive;

					}
					elseif(strpos($line[1],"Line 2"))
					{
						$arrayResult['Line2']['id'] = $service['id'];
						$arrayResult['Line2']['Line'] = $percent;
						$arrayResult['Line2']['State'] = $line[0];
						$arrayResult['Line2']['Volt'] = $service['value']['volt'];
						if(!empty($line[0]))
						{
						 $isActive = true;
						}
						$arrayResult['Line2']['isActive'] = $isActive;
					}
					elseif(strpos($line[1],"Line 3"))
					{
						$arrayResult['Line3']['id'] = $service['id'];
						$arrayResult['Line3']['Line'] = $percent;
						$arrayResult['Line3']['State'] = $line[0];
						$arrayResult['Line3']['Volt'] = $service['value']['volt'];
						if(!empty($line[0]))
						{
							$isActive = true;
						}
						$arrayResult['Line3']['isActive'] = $isActive;
					}
				}
				elseif($service['check_plugin_name'] == "CHECK_SNMP_UPS_INPUT" || $service['check_plugin_name'] == "GESA_SNMP_UPS_INPUT")
				{
					$line = explode(':',$service["stdout"]);
					$posPercent = strpos($line[2],'%');
					$percent = substr($line[2],$posPercent-2,$posPercent);
					$percent = substr($percent,0,2);
					if(preg_match('#([0-9]*)\%#',$service["stdout"],$regs))
					{
						$percent = $regs[1];
					}
					if(strpos($line[1],"Line 1"))
					{
						$arrayResult['in_Line1']['id'] = $service['id'];

						$arrayResult['in_Line1']['Line'] = $percent;
						$arrayResult['in_Line1']['State'] = $line[0];
						$arrayResult['in_Line1']['Volt'] = $service['value']['voltage'];
						if(!empty($line[0]))
						{
						 	$isActive = true;
						}
						$arrayResult['in_Line1']['isActive'] = $isActive;
					}
					elseif(strpos($line[1],"Line 2"))
					{
						$arrayResult['in_Line2']['id'] = $service['id'];
						$arrayResult['in_Line2']['Line'] = $percent;
						$arrayResult['in_Line2']['State'] = $line[0];
						$arrayResult['in_Line2']['Volt'] = $service['value']['voltage'];
						if(!empty($line[0]))
						{
						 $isActive = true;
						}
						$arrayResult['in_Line2']['isActive'] = $isActive;
					}
					elseif(strpos($line[1],"Line 3"))
					{
						$arrayResult['in_Line3']['id'] = $service['id'];
						$arrayResult['in_Line3']['Line'] = $percent;
						$arrayResult['in_Line3']['State'] = $line[0];
						$arrayResult['in_Line3']['Volt'] = $service['value']['voltage'];
						if(!empty($line[0]))
						{
							$isActive = true;
						}
						$arrayResult['in_Line3']['isActive'] = $isActive;
					}
				}
				elseif($service['check_plugin_name'] == "CHECK_SNMP_UPS_STATE" || $service['check_plugin_name'] == "GESA_SNMP_UPS_STATE")
				{
					$state = explode(':',$service['stdout']);
					$arrayResult['state'] = $state[0];
				}
				elseif($service['check_plugin_name'] == "CHECK_SNMP_UPS_BATTERY" || $service['check_plugin_name'] == "GESA_SNMP_UPS_BATTERY")
				{
					//Récupération de temps restant de la batterie
					$batteryInfo = explode(':',$service['stdout']);

					$stateres = 'UNKNOWN';
					switch($service['state'])
					{
						case 0: $stateres = 'OK'; break;
						case 1: $stateres = 'WARNING'; break;
						case 2: $stateres = 'CRITICAL'; break;
						case 5: $stateres = 'MAINTENANCE'; break;
						default: $stateres = 'UNKNOWN'; break;
					}
					$arrayResult['batteryState'] = $stateres;
					$timeRemaining= 'n/a';
					if(preg_match('#([0-9]+)\s+min#',$service['stdout'],$regs))
					{
						$timeRemaining = $regs[1].' min';
					}
					$arrayResult['timeBattery'] = $timeRemaining;
					// Récupération de charge de la batterie
					if(preg_match('#load\:\s+([0-9]*)\%#',$service['stdout'],$regs))
					{
						$arrayResult['levelBattery'] = $regs[1].'%';
					}
					// Récupération de la temperature de la batterie
					if(preg_match('#([0-9]*)\s+Celsius#',$service['stdout'],$regs))
					{
						$load = $regs[1];
						$arrayResult['tempBattery'] = $regs[1].'C°';
					}
				}

        }
        $smarty->assign('array',$arrayResult);
    }
	if($tab =='ups_Line')
	{
		$smarty->assign('nodeid',$_GET['nodeid']);
		$result = Model_esia::getServices($dbconnection,$_GET['nodeid']);
		$plugin_path = "";
		$lineActive = array();
		$inlineActive = array();
		$node = Model_esia::InstanceNode($dbconnection,$_REQUEST['nodeid']);
		foreach($result as $service)
		{
 			if(strpos($service['check_plugin_name'],"SNMP_UPS_LINE") !==FALSE)
			{
				$plugin_path = $service['path'];
				if(preg_match('#\-m\s+([0-9]*)#',$service['parameter'],$regs ))
				{
					$lineActive[] = $regs[1];
				}
				elseif(preg_match('#SNMP_COM\s+([0-9]*)#',$service['parameter'],$regs ))
				{
					$lineActive[] = $regs[1];
				}
			}
			elseif(strpos($service['check_plugin_name'],"SNMP_UPS_INPUT") !==FALSE)
			{
				$plugin_path = $service['path'];
				if(preg_match('#\-m\s+([0-9]*)#',$service['parameter'],$regs ))
				{
					$inlineActive[] = $regs[1];
				}
				elseif(preg_match('#SNMP_COM\s+([0-9]*)#',$service['parameter'],$regs ))
				{
					$inlineActive[] = $regs[1];
				}
			}
		}
		$smarty->assign('lineTab',$lineActive);
		$ip = $node->getIPAddress();
		$community = $node->getSNMPCommunity();
		if(get_class($node)=='RemoteDevice')
		{
			$out = $node->getGESA()->check_ecatp($node,'check_snmp_ups.pl',' -H '.$ip.' -C '.$community.' -T line -v 1 --json');
			$out= $out['data'];
		}
		else
		{
			if(empty($plugin_path))
			{
				$plugins = Model_esia::getPlugin($dbconnection,"CHECK_SNMP_UPS_LINE");
				$plugin = $plugins[0];
				$plugin_path = $plugin['path'];
			}
			exec($plugin_path.' -H '.$ip.' -C '.$community.' -T line -v 1 --json ',$out,$ret);
		}
		$str = json_decode($out[0],true);

		$countStr = count($str);
		for($i=0;$i< $countStr ;$i++)
		{
			$str[$i]['active'] = 0;
			if(in_array($str[$i]['id'],$lineActive))
			{
				$str[$i]['active'] = 1;
			}
		}
		$smarty->assign('arrayLine',$str);
		//INPUT
		if(get_class($node)=='RemoteDevice')
		{
			$out = $node->getGESA()->check_ecatp($node,'check_snmp_ups.pl',' -H '.$ip.' -C '.$community.' -T input -v 1 --json');
			$out= $out['data'];
		}
		else
		{
			if(empty($plugin_path))
			{
				$plugins = Model_esia::getPlugin($dbconnection,"CHECK_SNMP_UPS_LINE");
				$plugin = $plugins[0];
				$plugin_path = $plugin['path'];
			}
			exec($plugin_path.' -H '.$ip.' -C '.$community.' -T input -v 1 --json ',$out,$ret);
		}
		$str = json_decode($out[0],true);

		$countStr = count($str);
		for($i=0;$i< $countStr ;$i++)
		{
			$str[$i]['active'] = 0;
			if(in_array($str[$i]['id'],$inlineActive))
			{
				$str[$i]['active'] = 1;
			}
		}
		$smarty->assign('arrayInputLine',$str);
		$_SESSION['random'] = rand(100000,999999);
		$smarty->assign('hidden',$_SESSION['random']);
	}

}
//Traitement des exceptions SNMP et des erreurs de traitement dans la base de donnée
catch(DeviceNotAliveException $e)
{
	$smarty->assign('errors','no');
}
catch(DeviceSNMPException $e)
{
	$smarty->assign('error_snmp',$lang['ADM_ERR_SNMP_FAILED'].'<br/>'.$e->getMessage());
}
catch(DeviceException $e)
{
	$smarty->assign('error_snmp',$lang['ADM_ERR_SNMP_FAILED'].'<br/>'.$e->getMessage());
}
catch(Exception $e0)
{
	$smarty->assign('errors',$e->getMessage());
}


$smarty->display($template_path.'control_'.$webp_name.'.html');
?>
